//
// MATLAB RpC[:5.1 (R2014a)
// t:Fri Oct 31 19:04:10 2014
// : "-B" "macro_default" "-B" "cpplib:BMSLib" "-W" "cpplib:BMSLib" "-T"
// "link:lib" "BMSSaliencyModel.m" "delBMSdir.m" "makeBMSdir.m" 
//

#ifndef __BMSLib_h
#define __BMSLib_h 1

#if defined(__cplusplus) && !defined(mclmcrrt_h) && defined(__linux__)
#  pragma implementation "mclmcrrt.h"
#endif
#include "mclmcrrt.h"
#include "mclcppclass.h"
#ifdef __cplusplus
extern "C" {
#endif

#if defined(__SUNPRO_CC)
/* Solaris shared libraries use __global, rather than mapfiles
 * to define the API exported from a shared library. __global is
 * only necessary when building the library -- files including
 * this header file to use the library do not need the __global
 * declaration; hence the EXPORTING_<library> logic.
 */

#ifdef EXPORTING_BMSLib
#define PUBLIC_BMSLib_C_API __global
#else
#define PUBLIC_BMSLib_C_API /* No import statement needed. */
#endif

#define LIB_BMSLib_C_API PUBLIC_BMSLib_C_API

#elif defined(_HPUX_SOURCE)

#ifdef EXPORTING_BMSLib
#define PUBLIC_BMSLib_C_API __declspec(dllexport)
#else
#define PUBLIC_BMSLib_C_API __declspec(dllimport)
#endif

#define LIB_BMSLib_C_API PUBLIC_BMSLib_C_API


#else

#define LIB_BMSLib_C_API

#endif

/* This symbol is defined in shared libraries. Define it here
 * (to nothing) in case this isn't a shared library. 
 */
#ifndef LIB_BMSLib_C_API 
#define LIB_BMSLib_C_API /* No special import/export declaration */
#endif

extern LIB_BMSLib_C_API 
bool MW_CALL_CONV BMSLibInitializeWithHandlers(
       mclOutputHandlerFcn error_handler, 
       mclOutputHandlerFcn print_handler);

extern LIB_BMSLib_C_API 
bool MW_CALL_CONV BMSLibInitialize(void);

extern LIB_BMSLib_C_API 
void MW_CALL_CONV BMSLibTerminate(void);



extern LIB_BMSLib_C_API 
void MW_CALL_CONV BMSLibPrintStackTrace(void);

extern LIB_BMSLib_C_API 
bool MW_CALL_CONV mlxBMSSaliencyModel(int nlhs, mxArray *plhs[], int nrhs, mxArray 
                                      *prhs[]);

extern LIB_BMSLib_C_API 
bool MW_CALL_CONV mlxDelBMSdir(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[]);

extern LIB_BMSLib_C_API 
bool MW_CALL_CONV mlxMakeBMSdir(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[]);


#ifdef __cplusplus
}
#endif

#ifdef __cplusplus

/* On Windows, use __declspec to control the exported API */
#if defined(_MSC_VER) || defined(__BORLANDC__)

#ifdef EXPORTING_BMSLib
#define PUBLIC_BMSLib_CPP_API __declspec(dllexport)
#else
#define PUBLIC_BMSLib_CPP_API __declspec(dllimport)
#endif

#define LIB_BMSLib_CPP_API PUBLIC_BMSLib_CPP_API

#else

#if !defined(LIB_BMSLib_CPP_API)
#if defined(LIB_BMSLib_C_API)
#define LIB_BMSLib_CPP_API LIB_BMSLib_C_API
#else
#define LIB_BMSLib_CPP_API /* empty! */ 
#endif
#endif

#endif

extern LIB_BMSLib_CPP_API void MW_CALL_CONV BMSSaliencyModel(int nargout, mwArray& saliencyMap, const mwArray& img, const mwArray& sod);

extern LIB_BMSLib_CPP_API void MW_CALL_CONV delBMSdir();

extern LIB_BMSLib_CPP_API void MW_CALL_CONV makeBMSdir();

#endif
#endif
