# BMS CMake config file
#
# This file sets the following variables:
# BMS_FOUND - Always TRUE.
# BMS_INCLUDE_DIRS - Directories containing the BMS include files.
# BMS_IDL_DIRS - Directories containing the BMS IDL files.
# BMS_LIBRARIES - Libraries needed to use BMS.
# BMS_DEFINITIONS - Compiler flags for BMS.
# BMS_VERSION - The version of BMS found.
# BMS_VERSION_MAJOR - The major version of BMS found.
# BMS_VERSION_MINOR - The minor version of BMS found.
# BMS_VERSION_REVISION - The revision version of BMS found.
# BMS_VERSION_CANDIDATE - The candidate version of BMS found.

message(STATUS "Found BMS-1.1.0")
set(BMS_FOUND TRUE)

find_package(<dependency> REQUIRED)

#set(BMS_INCLUDE_DIRS
#    "C:/Program Files/BMS/include/bms-1"
#    ${<dependency>_INCLUDE_DIRS}
#    )
#
#set(BMS_IDL_DIRS
#    "C:/Program Files/BMS/include/bms-1/idl")
set(BMS_INCLUDE_DIRS
    "C:/Program Files/BMS/include/"
    ${<dependency>_INCLUDE_DIRS}
    )
set(BMS_IDL_DIRS
    "C:/Program Files/BMS/include//idl")


if(WIN32)
    set(BMS_LIBRARIES
        "C:/Program Files/BMS/components/lib/bms.lib"
        ${<dependency>_LIBRARIES}
        )
else(WIN32)
    set(BMS_LIBRARIES
        "C:/Program Files/BMS/components/lib/bms.dll"
        ${<dependency>_LIBRARIES}
        )
endif(WIN32)

set(BMS_DEFINITIONS ${<dependency>_DEFINITIONS})

set(BMS_VERSION 1.1.0)
set(BMS_VERSION_MAJOR 1)
set(BMS_VERSION_MINOR 1)
set(BMS_VERSION_REVISION 0)
set(BMS_VERSION_CANDIDATE )

